<!-- This file was generated by pybib2web, version 0.7.dev0: https://gitlab.com/sosy-lab/software/pybib2web/ -->
<input type="checkbox" id="show-compact">
<label for="show-compact">Compact view</label>
<h2 id="publications">Publications of year 2007</h2>
<nav class="publication-navigation">(<a href="../All/index.html">Show all</a> &ndash; <a href="../index.html">Index</a>)</nav>

<a href="../Category/conferences.html"><h3>Articles in conference or workshop proceedings</h3></a>

<ol class="list-publications" start="1">

<li class="bibentry" id="ICWS07">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Arindam</span> <span class="lastname">Chakrabarti</span></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Sanjit A.</span> <span class="lastname">Seshia</span></span>.</span>
    <span class="publication-title">An Application of Web-Service Interfaces.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 2007 IEEE International Conference on 
        Web Services
        (ICWS 2007, Salt Lake City, UT, July 9-13)</em>,
      <span class="pages">pages 831-838</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">IEEE Computer Society Press, Los Alamitos (CA).</span>
    <a class="doi" href="https://doi.org/10.1109/ICWS.2007.32" data-doi="10.1109/ICWS.2007.32" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/ICWS.2007.32</a>
  </span>
  <a class="bibentry-link" href="#ICWS07"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/INTERFACES-FOR-COMPONENT-BASED-DESIGN.html">Interfaces for Component-Based Design</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/ICWS.2007.32" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-ICWS.An_Application_of_Web-Service_Interfaces.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        We present a case study to illustrate our formalism
        for the specification and verification of the
        method-invocation behavior of web-service applications
        constructed from asynchronously interacting
        multi-threaded distributed components.  Our model is
        expressive enough to allow the representation of
        recursion and dynamic thread creation, and yet permits
        the algorithmic analysis of the following two
        questions: (1) Does a given service satisfy a safety
        specification?  (2) Can a given service be substituted
        by a another service in an arbitrary context?  Our
        case study is based on the Amazon.com E-Commerce
        Services (ECS) platform.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ICWS07,
        author = {Dirk Beyer and Arindam Chakrabarti and Thomas A.~Henzinger and Sanjit A. Seshia},
        title = {An Application of Web-Service Interfaces},
        booktitle = {Proceedings of the 2007 IEEE International Conference on  Web Services (ICWS~2007, Salt Lake City, UT, July 9-13)},
        pages = {831-838},
        year = {2007},
        publisher = {IEEE Computer Society Press, Los Alamitos~(CA)},
        isbn = {0-7695-2924-0},
        doi = {10.1109/ICWS.2007.32},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-ICWS.An_Application_of_Web-Service_Interfaces.pdf},
        abstract = {We present a case study to illustrate our formalism for the specification and verification of the method-invocation behavior of web-service applications constructed from asynchronously interacting multi-threaded distributed components.  Our model is expressive enough to allow the representation of recursion and dynamic thread creation, and yet permits the algorithmic analysis of the following two questions: (1) Does a given service satisfy a safety specification?  (2) Can a given service be substituted by a another service in an arbitrary context?  Our case study is based on the Amazon.com E-Commerce Services (ECS) platform.},
        keyword = {Interfaces for Component-Based Design},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="CAV07b">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Vasu</span> <span class="lastname">Singh</span></span>.</span>
    <span class="publication-title">Algorithms for Interface Synthesis.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">W.</span> <span class="lastname">Damm</span></span> and
      <span class="editor"><span class="firstname">H.</span> <span class="lastname">Hermanns</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 19th International Conference on
        Computer Aided Verification 
        (CAV 2007, Berlin, July 3-7)</em>,
      <span class="series">LNCS 4590</span>,
      <span class="pages">pages 4-19</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-73368-3_4" data-doi="10.1007/978-3-540-73368-3_4" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-73368-3_4</a>
  </span>
  <a class="bibentry-link" href="#CAV07b"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/INTERFACES-FOR-COMPONENT-BASED-DESIGN.html">Interfaces for Component-Based Design</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-73368-3_4" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-CAV.Algorithms_for_Interface_Synthesis.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        A temporal interface for a software component is a
        finite automaton that specifies the legal sequences of
        calls to functions that are provided by the component.
        We compare and evaluate three different algorithms for
        automatically extracting temporal interfaces from
        program code: (1) a game algorithm that computes the
        interface as a representation of the most general
        environment strategy to avoid a safety violation; (2)
        a learning algorithm that repeatedly queries the
        program to construct the minimal interface automaton;
        and (3) a CEGAR algorithm that iteratively refines an
        abstract interface hypothesis by adding relevant
        program variables.  For comparison purposes, we
        present and implement the three algorithms in a
        unifying formal setting.  While the three algorithms
        compute the same output and have similar worst-case
        complexities, their actual running times may differ
        considerably for a given input program.  On the
        theoretical side, we provide for each of the three
        algorithms a family of input programs on which that
        algorithm outperforms the two alternatives.  On the
        practical side, we evaluate the three algorithms
        experimentally on a variety of Java libraries.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{CAV07b,
        author = {Dirk Beyer and Thomas A.~Henzinger and Vasu Singh},
        title = {Algorithms for Interface Synthesis},
        booktitle = {Proceedings of the 19th International Conference on Computer Aided Verification  (CAV~2007, Berlin, July 3-7)},
        editor = {W.~Damm and H.~Hermanns},
        pages = {4-19},
        year = {2007},
        series = {LNCS~4590},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-540-73367-6},
        doi = {10.1007/978-3-540-73368-3_4},
        sha256 = {c8d7d6300d354fb38917b44cb9fbd3ebbad1737d75107ccc124af001677679ec},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-CAV.Algorithms_for_Interface_Synthesis.pdf},
        abstract = {A temporal interface for a software component is a finite automaton that specifies the legal sequences of calls to functions that are provided by the component. We compare and evaluate three different algorithms for automatically extracting temporal interfaces from program code: (1) a game algorithm that computes the interface as a representation of the most general environment strategy to avoid a safety violation; (2) a learning algorithm that repeatedly queries the program to construct the minimal interface automaton; and (3) a CEGAR algorithm that iteratively refines an abstract interface hypothesis by adding relevant program variables.  For comparison purposes, we present and implement the three algorithms in a unifying formal setting.  While the three algorithms compute the same output and have similar worst-case complexities, their actual running times may differ considerably for a given input program.  On the theoretical side, we provide for each of the three algorithms a family of input programs on which that algorithm outperforms the two alternatives.  On the practical side, we evaluate the three algorithms experimentally on a variety of Java libraries.},
        keyword = {Interfaces for Component-Based Design,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="CAV07a">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Grégory</span> <span class="lastname">Théoduloz</span></span>.</span>
    <span class="publication-title">Configurable Software Verification:
    Concretizing the Convergence of 
    Model Checking and Program Analysis.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">W.</span> <span class="lastname">Damm</span></span> and
      <span class="editor"><span class="firstname">H.</span> <span class="lastname">Hermanns</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 19th International Conference on
        Computer Aided Verification 
        (CAV 2007, Berlin, July 3-7)</em>,
      <span class="series">LNCS 4590</span>,
      <span class="pages">pages 504-518</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-73368-3_51" data-doi="10.1007/978-3-540-73368-3_51" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-73368-3_51</a>
  </span>
  <a class="bibentry-link" href="#CAV07a"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/BLAST.html">BLAST</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-73368-3_51" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-CAV.Configurable_Software_Verification.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2007-07-07_CAV07_Configurable-Program-Analysis.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        In automatic software verification, we have observed a
        theoretical convergence of model checking and program
        analysis.  In practice, however, model checkers are
        still mostly concerned with precision, e.g., the
        removal of spurious counterexamples; for this purpose
        they build and refine reachability trees.
        Lattice-based program analyzers, on the other hand,
        are primarily concerned with efficiency.  We designed
        an algorithm and built a tool that can be configured
        to perform not only a purely tree-based or a purely
        lattice-based analysis, but offers many intermediate
        settings that have not been evaluated before.  The
        algorithm and tool take one or more abstract
        interpreters, such as a predicate abstraction and a
        shape analysis, and configure their execution and
        interaction using several parameters.  Our experiments
        show that such customization may lead to dramatic
        improvements in the precision-efficiency spectrum.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{CAV07a,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Gr{\&#x27;e}gory Th{\&#x27;e}oduloz},
        title = {Configurable Software Verification: Concretizing the Convergence of  Model Checking and Program Analysis},
        booktitle = {Proceedings of the 19th International Conference on Computer Aided Verification  (CAV~2007, Berlin, July 3-7)},
        editor = {W.~Damm and H.~Hermanns},
        pages = {504-518},
        year = {2007},
        series = {LNCS~4590},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-540-73367-6},
        doi = {10.1007/978-3-540-73368-3_51},
        sha256 = {1c5d0f57fdded4d659c5a86984e19307c50d7770442fa908db20430a22e4b276},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-CAV.Configurable_Software_Verification.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2007-07-07_CAV07_Configurable-Program-Analysis.pdf},
        abstract = {In automatic software verification, we have observed a theoretical convergence of model checking and program analysis.  In practice, however, model checkers are still mostly concerned with precision, e.g., the removal of spurious counterexamples; for this purpose they build and refine reachability trees. Lattice-based program analyzers, on the other hand, are primarily concerned with efficiency.  We designed an algorithm and built a tool that can be configured to perform not only a purely tree-based or a purely lattice-based analysis, but offers many intermediate settings that have not been evaluated before.  The algorithm and tool take one or more abstract interpreters, such as a predicate abstraction and a shape analysis, and configure their execution and interaction using several parameters.  Our experiments show that such customization may lead to dramatic improvements in the precision-efficiency spectrum.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="PLDI07">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>, and
    <span class="author"><span class="firstname">Andrey</span> <span class="lastname">Rybalchenko</span></span>.</span>
    <span class="publication-title">Path Invariants.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 2007 ACM Conference on
        Programming Language Design and Implementation
        (PLDI 2007, San Diego, CA, June 10-13)</em>,
      <span class="pages">pages 300-309</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">ACM Press, New York (NY).</span>
    <a class="doi" href="https://doi.org/10.1145/1250734.1250769" data-doi="10.1145/1250734.1250769" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1145/1250734.1250769</a>
  </span>
  <a class="bibentry-link" href="#PLDI07"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/BLAST.html">BLAST</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1145/1250734.1250769" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-PLDI.Path_Invariants.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        The success of software verification depends on the
        ability to find a suitable abstraction of a program
        automatically.  We propose a method for automated
        abstraction refinement which overcomes some
        limitations of current predicate discovery schemes.
        In current schemes, the cause of a false alarm is
        identified as an infeasible error path, and the
        abstraction is refined in order to remove that path.
        By contrast, we view the cause of a false alarm -the
        spurious counterexample- as a full-fledged program,
        namely, a fragment of the original program whose
        control-flow graph may contain loops and represent
        unbounded computations.  There are two advantages to
        using such path programs as counterexamples for
        abstraction refinement.  First, we can bring the whole
        machinery of program analysis to bear on path
        programs, which are typically small compared to the
        original program.  Specifically, we use
        constraint-based invariant generation to automatically
        infer invariants of path programs -so-called path
        invariants.  Second, we use path invariants for
        abstraction refinement in order to remove not one
        infeasibility at a time, but at once all (possibly
        infinitely many) infeasible error computations that
        are represented by a path program.  Unlike previous
        predicate discovery schemes, our method handles loops
        without unrolling them; it infers abstractions that
        involve universal quantification and naturally
        incorporates disjunctive reasoning.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{PLDI07,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Rupak Majumdar and Andrey Rybalchenko},
        title = {Path Invariants},
        booktitle = {Proceedings of the 2007 ACM Conference on Programming Language Design and Implementation (PLDI~2007, San Diego, CA, June 10-13)},
        pages = {300-309},
        year = {2007},
        publisher = {ACM Press, New York~(NY)},
        isbn = {978-1-59593-633-2},
        doi = {10.1145/1250734.1250769},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-PLDI.Path_Invariants.pdf},
        abstract = {The success of software verification depends on the ability to find a suitable abstraction of a program automatically.  We propose a method for automated abstraction refinement which overcomes some limitations of current predicate discovery schemes. In current schemes, the cause of a false alarm is identified as an infeasible error path, and the abstraction is refined in order to remove that path. By contrast, we view the cause of a false alarm ---the spurious counterexample--- as a full-fledged program, namely, a fragment of the original program whose control-flow graph may contain loops and represent unbounded computations.  There are two advantages to using such path programs as counterexamples for abstraction refinement.  First, we can bring the whole machinery of program analysis to bear on path programs, which are typically small compared to the original program.  Specifically, we use constraint-based invariant generation to automatically infer invariants of path programs ---so-called path invariants.  Second, we use path invariants for abstraction refinement in order to remove not one infeasibility at a time, but at once all (possibly infinitely many) infeasible error computations that are represented by a path program.  Unlike previous predicate discovery schemes, our method handles loops without unrolling them; it infers abstractions that involve universal quantification and naturally incorporates disjunctive reasoning.},
        keyword = {BLAST,Software Model Checking},
        annote = {Video: &lt;a href=&quot;https://www.youtube.com/watch?v=vUN0n23zVuw&quot;&gt; https://www.youtube.com/watch?v=vUN0n23zVuw&lt;/a&gt;&lt;BR&gt;},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        
        Video:
        <a href="https://www.youtube.com/watch?v=vUN0n23zVuw">
        https://www.youtube.com/watch?v=vUN0n23zVuw</a><BR>
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="VMCAI07">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>, and
    <span class="author"><span class="firstname">Andrey</span> <span class="lastname">Rybalchenko</span></span>.</span>
    <span class="publication-title">Invariant Synthesis for Combined Theories.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">B.</span> <span class="lastname">Cook</span></span> and
      <span class="editor"><span class="firstname">A.</span> <span class="lastname">Podelski</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the Eighth International Conference on
        Verification, Model Checking, and Abstract Interpretation
        (VMCAI 2007, Nice, January 14-16)</em>,
      <span class="series">LNCS 4349</span>,
      <span class="pages">pages 378-394</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-69738-1_27" data-doi="10.1007/978-3-540-69738-1_27" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-69738-1_27</a>
  </span>
  <a class="bibentry-link" href="#VMCAI07"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/BLAST.html">BLAST</a>,
        <a class="keyword" href="../Keyword/SOFTWARE-MODEL-CHECKING.html">Software Model Checking</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-69738-1_27" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-VMCAI.Invariant_Synthesis_for_Combined_Theories.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        We present a constraint-based algorithm for the
        synthesis of invariants expressed in the combined
        theory of linear arithmetic and uninterpreted function
        symbols.  Given a set of programmer-specified
        invariant templates, our algorithm reduces the
        invariant synthesis problem to a sequence of
        arithmetic constraint satisfaction queries.  Since the
        combination of linear arithmetic and uninterpreted
        functions is a widely applied predicate domain for
        program verification, our algorithm provides a
        powerful tool to statically and automatically reason
        about program correctness.  The algorithm can also be
        used for the synthesis of invariants over arrays and
        set data structures, because satisfiability questions
        for the theories of sets and arrays can be reduced to
        the theory of linear arithmetic with uninterpreted
        functions.  We have implemented our algorithm and used
        it to find invariants for a low-level memory allocator
        written in C.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{VMCAI07,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Rupak Majumdar and Andrey Rybalchenko},
        title = {Invariant Synthesis for Combined Theories},
        booktitle = {Proceedings of the Eighth International Conference on Verification, Model Checking, and Abstract Interpretation (VMCAI~2007, Nice, January 14-16)},
        editor = {B.~Cook and A.~Podelski},
        pages = {378-394},
        year = {2007},
        series = {LNCS~4349},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-540-69735-0},
        doi = {10.1007/978-3-540-69738-1_27},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-VMCAI.Invariant_Synthesis_for_Combined_Theories.pdf},
        abstract = {We present a constraint-based algorithm for the synthesis of invariants expressed in the combined theory of linear arithmetic and uninterpreted function symbols.  Given a set of programmer-specified invariant templates, our algorithm reduces the invariant synthesis problem to a sequence of arithmetic constraint satisfaction queries.  Since the combination of linear arithmetic and uninterpreted functions is a widely applied predicate domain for program verification, our algorithm provides a powerful tool to statically and automatically reason about program correctness.  The algorithm can also be used for the synthesis of invariants over arrays and set data structures, because satisfiability questions for the theories of sets and arrays can be reduced to the theory of linear arithmetic with uninterpreted functions.  We have implemented our algorithm and used it to find invariants for a low-level memory allocator written in C.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

</ol>
 <section id="disclaimer"> <h4>Disclaimer:</h4> <p class="disclaimer"> This material is presented to ensure timely dissemination of scholarly and technical work. Copyright and all rights therein are retained by authors or by other copyright holders. All person copying this information are expected to adhere to the terms and constraints invoked by each author's copyright. In most cases, these works may not be reposted without the explicit permission of the copyright holder. </p> </section> <footer id="generator">This file was generated by <a href="https://gitlab.com/sosy-lab/software/pybib2web/">pybib2web</a>, version 0.7.dev0</footer>